# VLC for Android
This is the official **Android** port of [VLC](https://videolan.org/vlc/).

VLC on Android plays all the same files as the classical version of VLC, and features a media database
for Audio and Video files and stream.

## License
VLC for Android is licensed under GPLv2 (or later). Android libraries makes this, de facto, a GPLv3 application.

VLC engine *(libvlc)* for Android is licensed under LGPL.

## Build

You will need a recent Linux distribution to build VLC.
It should work with Windows 10, and macOS, but there is no official support for this.

Check our [AndroidCompile wiki page](https://wiki.videolan.org/AndroidCompile/)

## Contribute

VLC is a libre and open source project, we welcome all contributions.

Just respect our [Code of Conduct](https://wiki.videolan.org/CoC/).

### Pull requests

Pull requests can be proposed here or on our [github mirror](https://github.com/videolan/vlc-android).

### Sending patches to the mailing list

Check [our wiki page on how to send patches](https://wiki.videolan.org/Sending_Patches_VLC/)
Send them to the android mailing list: android@videolan.org, not vlc-devel.

## Issues and feature requests

VLC for Android bugtracker is hosted on [VideoLAN gitlab](https://code.videolan.org/videolan/vlc-android/issues)
Please look for existing issues and provide as much useful details as you can (e.g. vlc app version, device and Android version)

### Translations:
You can help improving translations too by joining the [transifex vlc project](https://www.transifex.com/yaron/vlc-trans/dashboard/)

## LibVLC
You can use our LibVLC module to power your own Android media player.
Have a look at our  [sample codes](https://code.videolan.org/videolan/libvlc-android-samples).

## support

- Android mailing list: android@videolan.org
- bugtracker: https://code.videolan.org/videolan/vlc-android/issues
- IRC: *#videolan* channel on [freenode](http://freenode.net/)
- VideoLAN forum: https://forum.videolan.org/
- G+ community: https://plus.google.com/u/0/communities/113615952107012455563

